
/*
 * pbrt source code Copyright(c) 1998-2005 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For educational use only; commercial use expressly forbidden.
 * NO WARRANTY, express or implied, for this software.
 * (See file License.txt for complete license)
 */

// pbrt.cpp*
#include "pbrt.h"
#include "api.h"
#include <time.h>
// main program
int main(int argc, char *argv[]) {
	// Print welcome banner
    /* irritating
	printf("pbrt version %1.3f of %s at %s\n",
	       PBRT_VERSION, __DATE__, __TIME__);
	printf("Copyright (c)1998-2005 Matt Pharr and "
	       "Greg Humphreys.\n");
	printf("For educational use only; commercial use expressly forbidden.\n");
    */

    // print start time
    time_t	start, end;
    struct	tm	date_time;

    start = time(NULL);
    date_time = *localtime(&start);
    printf("Render Start: %s", asctime(&date_time));

	fflush(stdout);
	pbrtInit();
	// Process scene description
	if (argc == 1) {
		// Parse scene from standard input
		ParseFile("-");
	} else {
		// Parse scene from input files
		for (int i = 1; i < argc; i++)
			if (!ParseFile(argv[i]))
				Error("Couldn't open scene file \"%s\"\n", argv[i]);
	}
	pbrtCleanup();

    // print end time
    end = time(NULL);
    date_time = *localtime(&end);
    printf("Render End:   %s", asctime(&date_time));
    int m = (end - start) / 60;
    int s = (end - start) % 60;
    printf("Total Time: %02i:%02i", m, s);

    return 0;
}
